﻿
using FLY.Thick.Blowing.IService.IShareDBServicePack;
using FLY.Thick.Blowing.Server.Model;
using FObjBase;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FLY.Thick.Blowing.IService
{
    public interface IShareDBService
    {
        void GetProfile(AsyncCBHandler asyncDelegate, object asyncContext);
        event ProfileChangedEventHandler ProfileChanged;
        event ScanDataChangedEventHandler ScanDataChanged;
        void FinishProfile();
    }
}
namespace FLY.Thick.Blowing.IService.IShareDBServicePack
{
    public class ProfileChangedEventArgs
    {
        /// <summary>
        /// 不是insert，就是update
        /// </summary>
        public bool isInsert;

        public DB_Profile profile;
    }
    public delegate void ProfileChangedEventHandler(object sender, ProfileChangedEventArgs e);


    public class ScanDataChangedEventArgs
    {
        /// <summary>
        /// 不是insert，就是update
        /// </summary>
        public bool isInsert;

        public LC_ScanData scandata;
    }
    public delegate void ScanDataChangedEventHandler(object sender, ScanDataChangedEventArgs e);
}
