﻿using FLY.OBJComponents.Server.Model;
using SQLite;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FLY.Thick.Blowing.Server.Model
{
    public class DBModel:SQLiteDbContext,IErrorDBModel
    {
        public DBTable<DB_Profile> TbProfile { get; } = new DBTable<DB_Profile>();
        public DBTable<DB_ScanData> TbScanData { get; } = new DBTable<DB_ScanData>();
        public DBTable<DB_Error> TbError { get; } = new DBTable<DB_Error>();

        public DBModel(string dbpath) : base(dbpath)
        {

        }
        public DBModel() : this(@"D:\flydata\thick_history.sqlite3")
        {

        }
    }
}
