﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Misc;
using System.Net;
using System.Xml;
using System.Xml.Linq;
using System.ComponentModel;


namespace FLY.Thick.Blowing.UI.Fix.Client
{
    public class SysParam : ThickTcpUiInWindow.SysParam
    {
        #region 数据文件需要保存的数据项
        public int WindowSize { get; set; } = 30;
        /// <summary>
        /// USB 继电器 串口地址
        /// </summary>
        public string LCUS1_PortName { get; set; } = "COM1";
        /// <summary>
        /// 使能USB 继电器
        /// </summary>
        public bool EnableLCUS1 { get; set; }
        #endregion


        public SysParam()
        {

        }

        public override string[] GetSavePropertyNames()
        {
            List<string> propertynames = new List<string>();
            propertynames.AddRange(base.GetSavePropertyNames());
            propertynames.AddRange(new string[]{
                "WindowSize",
                "LCUS1_PortName",
                "EnableLCUS1"
            });
            return propertynames.ToArray();
        }
    }
}
